! linklib.h
! Libreria alternativa a hyperlink per Inform 6 / Glulx
! Paolo Lucchesi, 2013-2015 

System_File;

!!! IMPOSSIBILE COMPILARE IN ZCODE
#IfNDef TARGET_GLULX;
  message fatalerror "Hyperlinks don't work in z-code. Use the -G switch to compile in glulx format.";
#EndIf;

Constant NULL         = $ffffffff;

#IfDef DEBUG; ! Boh, di colpo ha inziato a chiedere questa roba
Global debug_flag;
Attribute workflag;
Stub DebugAttribute 0;
#EndIf;

Include "infglk"; ! Il file degli header di Zarf

! Array per tenere i risultati di alcune chiamate glk
Array gg_event --> 4;
Array gg_arguments --> 8;

! Capacit@`a dell'interprete
Global gs_graphic=false;
Global gs_hyperlink=false;
Global gs_timer=false;

Global currentstyleglk=Style_Normal;

! Definiamo le finestre e i relativi rock
Constant GG_MAINWIN_ROCK 220;
Constant GG_STATUSWIN_ROCK 221;
Global gg_mainwin = 0;
Global gg_statuswin = 0;
#IfDef STATUS_WIN_UFRAME;
  Constant GG_STATUSWINUF_ROCK 229;
  Global gg_statuswinuf = 0;
#Endif;
CONSTANT GG_SAVESTR_ROCK 301;
Global gg_savestr = 0;

Global location = 0; ! In quale Node siamo?
Global printedloc = 0; ! Qual e' l'ultimo node stampato?
!Global lastlocation = 0; ! Il Node del turno scorso
Global player = 0; ! Quale oggetto rappresenta il giocatore?
Global keypressed = 0; 
Global usedtool = 0;
Global toolmode = 0; ! 0->auto, 1->da desc, 2->con action, *-1 se ~tool a cambio loc
Global linktimer = -1;
Global lastlinktimer = 0;
Global lastlink = 0;
Global promptlinks = true;
Global undoflag = true;
Global undoneturn = false;
Global statuscommands = true;

!Global gamerunning = 0;

Object playerobj; ! L'oggetto giocatore base

Object LibraryExtensions;
! Tutte le estensioni possono definire un oggetto, figlio di LibraryExtension
! per compiere certe azioni

! Attributi e proprieta' usati per ora
Attribute general;
Attribute locked;
Attribute moved;
Attribute open;
Attribute on;
Attribute visited;
Property additive description;
Property describe;
Property initial;
Property map;
Property submap;
Property cant_do;
Property short_name;
Property link_name;
Property found_in;
Property count 0;
Property condition;
Property additive each_turn;
Property additive react_before;
Property additive react_after;
Property homonym;

! Le Classi usate per ora nel gioco
Class Node;
Class Action;
Class Item;
Class Scenery; ! Non sono sicuro del nome Scenery
Class Tool;
Class KeyLink; ! Oggetti dei menu di sistema
Class MLink; ! Elementi di un menu

! Gli oggetti legati al menu in alto a destra e ai menu di scelta
! Nella propriata' command c'e' cosa appare nel finto prompt
! Nella proprieta' description c'e' cosa fanno...
Object syslinks;
KeyLink -> waitlink with 
    command "Aspetta",
    keys 'w' 'W' 'z' 'Z',
    description [; 
      if (~~DoReactBefore(waitlink)) print "Il tempo passa...^"; 
      DoReactAfter(waitlink); 
      DoEachTurn(); print "^"; 
    ];
KeyLink -> invlink with 
    command "Inventario",
    keys 'i' 'I',
    description [; inventory(); ];
KeyLink -> looklink with 
    command "Guarda",
    keys 'g' 'G' 'l' 'L',
    description [; printedloc = 0; ""; ]; !!! Deve fare DoReactAfter?
KeyLink -> menulink with 
    command "Menu",
    keys keycode_Escape 'm' 'M',
    description [; linemenu(systemmenu); ];
#IfDef DEBUG;
KeyLink -> skiplink with 
    command "Skip",
    keys keycode_Func8,
    description [; skip(); ];
#EndIf;

Object choicelinks;
MLink -> yeslink with keys 's' 'S' 'y' 'Y';
MLink -> nolink with keys 'n' 'N' keycode_Escape;
MLink -> morelink with keys ' ' keycode_Escape keycode_Return keycode_Tab;

! La routine principale
[ Main id x k drawprompt;
    TestGlkCapabilities();
    GlkInit(); ! Inizializzo le finestre
    if (gs_hyperlink == false) {
        print "Interpreter don't support Hyperlinks.^^";
        quit;
    }    
#IfNDef NOTIMER;    
    if (gs_timer) {
      linktimer=0; glk_request_timer_events(125);
    }
#EndIf;
    objectloop (x in LibraryExtensions) {
      if (x provides initial) x.initial();
    }      
    player = playerobj;
    drawprompt = true;
    DrawStatus(); ! Metto il men@`u anche all'inizio
    print "^";
    Initialize(); ! Initialize @`e definita obbligatoriamente dall'autore
                  ! e deve obbligatoriamente impostare location
    ! Loop principale... Se location = 0 esco
    ! lastlocation = location;
    while(location) {
        ! Se la locazione corrente e' diversa dall'ultima stampata, la stampiamo
        !SaveUndo();
        if (printedloc ~= location) {
            DescribeRoom();
!            DrawStatus();
!            ! printedloc = location;
!            !print "^";
!            give location visited;
!            SetStyle(style_Subheader);
!            print (name)location; print "^";
!            SetStyle(style_Normal);
!            location.description();
!            print "^";
!            ! Stampo tutti gli oggetti figli della location corrente
!            ! che abbiano una propriet@`a describe o initial (se non
!            ! sono moved, prioritaria), che non siano locked e che non
!            ! abbiano una proprieta' condition che ritorna false
!            k = false;
!            objectloop (x in location) {
!              if (x provides condition && ~~x.condition()) continue;
!              if (x has locked) continue;
!              if (x provides initial && x hasnt moved) {
!                if (x.initial()) { k = true; continue; }
!              }
!              if (x provides describe) {
!                if (x.describe()) k = true;
!                !PrintRun(x.describe); 
!              }
!            }
!            if (k) print "^";
!            ! Stampo tutte le Action figlie della locazione corrente
!            ! che non siano locked e che non abbiano una proprieta'
!            ! condition che ritorna false
!            k = false;
!            objectloop(x in location) {
!              if (x ofclass Action && x hasnt locked)
!                if (x provides condition && ~~x.condition()) ;
!                else { link(x); print (name)x; link(0); print "^"; k=1;  }
!            }
!            if (k) print "^";
            ! Infine le azioni da fare al cambio di locazione
            id = location;
            if (printedloc && toolmode<0) usedtool = 0; remove toolaction;
            if (player && usedtool) if (usedtool notin player) usedtool = 0;
            if (printedloc) DoEachTurn();
            ! Se la location e' stata cambiata ripetiamo
            if (id ~= location) { printedloc=id; print "^"; continue; }
            printedloc = location; 
        }
        ! print "^";
        ! Ok, aspetto che venga cliccato un link
        SaveUndo();
        SetStyle(style_Input);
        if (drawprompt) {
            if (promptlinks) {
                link(invlink); print " I "; link(0); print "|";
                link(looklink); print " L "; link(0); print "|";
                link(waitlink); print " W "; link(0); ! print " ";
            }
            print ">";
        }
        drawprompt = true;
        id = 0; 
        while (id == 0) {
            id = GetLinkKey(syslinks);
            if (id ofclass MLink) id = 0;
            if (id<0) id = 0;
        }
        ! Vediamo se una locazione deve essere trasformata da submap
        if (id ofclass Node) {
          if (~(id == location || TestMap(id))) {
              k=EvalSubMap(id);
              if (k) id = k;
          }
        }
        ! Stampiamo il comando associato, se esite        
        k = 1;
!        if (id < 0) {
!            drawprompt = false;
!            if (keypressed == 'w' or 'W' or 'z' or 'Z') {drawprompt = true; waitlink.command(); }
!            if (keypressed == keycode_Escape or 'm' or 'M') {drawprompt = true; menulink.command(); }
!            if (keypressed == 'g' or 'l' or 'G' or 'L') {drawprompt = true; looklink.command(); }
!            if (keypressed == 'i' or 'I') {drawprompt = true; invlink.command(); }
!            k = 0;
!        }        
        ! Controllo se le estensioni hanno un loro modo di scrivere il comando
        objectloop (x in LibraryExtensions) {
          if (x provides command) {
            if (x.command(id)) {k = 0; continue;}
          }
        }        
        ! Scrivo il comando associato, o esamina id
        if (k && id provides command) if (id.command()) k = 0;
        if (k && id ofclass Action) { k=0; print (name)id, "^"; }
        if (k) print "Esamina ", (artname)id, "^";
        SetStyle(style_Normal);
        !print "^";
        !print id;
        ! Se invece di un link e' stato premuto un tasto, a seconda del tasto
        ! premuto chiamo la funzione di una voce del menu di sisetma 
!        if (id < 0) {
!            if (keypressed == 'w' or 'W' or 'z' or 'Z') waitlink.description();
!            if (keypressed == keycode_Escape or 'm' or 'M') menulink.description();
!            if (keypressed == 'g' or 'l' or 'G' or 'L') looklink.description();
!            if (keypressed == 'i' or 'I') invlink.description();
!            continue;
!        }
        ! Se viene premuto un entry di menu non faccio niente
        if (id ofclass MLink) continue;
        ! Se viene premuto un link di sistema...
        if (id ofclass KeyLink) {
          if (id provides description) id.description();
          continue; ! Fine giro, senza le azioni di fine turno
                    ! (Il link per wait esegue DoReactBefore(); DoReactAfter(); e DoEachTurn(); )
        }
        !!! Se qualche reactbefore restituisce true, chiudo il turno
        if (DoReactBefore(id)) {
          DoReactAfter(id); DoEachTurn();
          print "^"; continue;
        }
        ! Se il link @`e un nuovo nodo, verifico che sia diverso e che ci si
        ! possa arrivare, e allora mi sposto e non eseguo le azioni di fine turno
        if (id ofclass Node) { 
            if (id == location) { print "Sei gi@`a qui.^^"; continue; }
            if (TestMap(id))    { location = id; DoReactAfter(id); print "^"; } ! era DoEachTurn();
            else                print "Non puoi arrivarci direttamente da qui.^^";
            continue;
        }
        k = 0;
        ! Controllo se le estensioni hanno un loro modo di interpretare il link
        objectloop (x in LibraryExtensions) {
          if (x provides process) {
            if (x.process(id)) {k=1; continue;}
          }
        }
        if (k) { DoReactAfter(id); DoEachTurn(); print "^"; continue; }
        ! Controllo se il link e' in scope
        if (~~TestScope(id)) { 
           k = TestHomonym(id); 
           if (k) {
                id = k;
           } else {
                if (id ofclass Action) print "Non puoi farlo adesso.^^";
                !else print "Non @`e qui al momento.^^"; 
                else print "Non vedi niente del genere.^^"; 
                continue; 
           }
        }
        ! Controllo se il link e' eseguibile
        if ((id provides condition && ~~id.condition()) || id has locked) {
            if ((id provides cant_do) && id.cant_do()) { print "^"; continue; }
            print "Non puoi farlo adesso.^^";
            continue;
        }
        ! Eseguo la description del link e le azioni di fine turno
        id.description();
        k = 0;
        if (id in player && id ofclass Tool && toolmode == 2 or -2) move toolaction to id;
        if (id in player && id ofclass Tool && usedtool ~= id && toolmode == 1 or -1) {
          usedtool = id;
          print "Adesso stai utilizzando ", (artname)usedtool, ".^";
        }
        ! Stampo tutte le Action figlie del link cliccato
        ! che non siano locked e che non abbiano una proprieta'
        ! condition che ritorna false
        objectloop(x in id) {
          if (x ofclass Action && x hasnt locked) { 
              if (x provides condition && ~~x.condition()) ;
              else { link(x); print (name)x; link(0); print "^"; k=1;  }
          }
        }
        ! Azioni di fine turno
        DoReactAfter(id); 
        if (location == printedloc) DoEachTurn(); 
        !if (k) print "111^";        
        print "^";
    }
    print "^^";
];

[ DescribeRoom flag; return(_DescribeRoom(flag)); ];

[ _DescribeRoom flag x k;
    DrawStatus();
    ! printedloc = location;
    !print "^";
    give location visited;
    SetStyle(style_Subheader);
    print (name)location; print "^";
    SetStyle(style_Normal);
    location.description();
    print "^";
    ! Stampo tutti gli oggetti figli della location corrente
    ! che abbiano una propriet@`a describe o initial (se non
    ! sono moved, prioritaria), che non siano locked e che non
    ! abbiano una proprieta' condition che ritorna false
    k = false;
    objectloop (x in location) {
      if (x provides condition && ~~x.condition()) continue;
      if (x has locked) continue;
      if (x provides initial && x hasnt moved) {
        if (x.initial()) { k = true; continue; }
      }
      if (x provides describe) {
        if (x.describe()) k = true;
        !PrintRun(x.describe); 
      }
    }
    if (k) print "^";
    ! Stampo tutte le Action figlie della locazione corrente
    ! che non siano locked e che non abbiano una proprieta'
    ! condition che ritorna false
    k = false;
    objectloop(x in location) {
      if (x ofclass Action && x hasnt locked)
        if (x provides condition && ~~x.condition()) ;
        else { link(x); print (name)x; link(0); print "^"; k=1;  }
    }
    if (k) print "^";
    if (flag) printedloc = location;
];

[ Evaluate id redesc x k;
    ! Questa funzione ricontrolla un oggetto stampando le azioni derivate
    ! Se il secondo parametro e' true ristampa anche la descrizione
    if (redesc) id.description();
    k = 0;
    ! Stampo tutte le Action figlie del link cliccato
    ! che non siano locked e che non abbiano una proprieta'
    ! condition che ritorna false
    objectloop(x in id) {
      if (x ofclass Action && x hasnt locked) { 
          if (x provides condition && ~~x.condition()) ;
          else { link(x); print (name)x; link(0); print "^"; k=1;  }
      }
    }
];

[ TestScope id n i;
    ! Un link e' in scope se e' discendente della location, del player
    ! Oppure ha la location nella propriet@`a found_in
    ! O se @`e un discendente della propriet@`a found_in!!!
    if (id == location) rtrue;
    if (id == player) rtrue;
    if (id provides found_in) {
        n = id.#found_in / WORDSIZE;
        for (i=0: i<n: i++)
            if (id.&found_in-->i == location) rtrue;
    }
    if (parent(id)) return(TestScope(parent(id)));    
    rfalse;    
];

[ TestHomonym id n i x;
    if (id provides homonym) {
        n = id.#homonym / WORDSIZE;
        for (i=0: i<n: i++) {
            x = id.&homonym-->i;
            if (TestScope(x)) return(x);
        }
    }
    rfalse;
];

[ DoReactBefore cmd;
    ! Azioni da fare prima di eseguire comando
    !print "*** react before ***^";
    if (DoReactBeforeFrom(location, cmd)) rtrue;
    if (DoReactBeforeFrom(player, cmd)) rtrue;
    rfalse;
];

[ DoReactBeforeFrom id cmd;
    ! Eseguo la propriet@`a react_before di id, poi proseguo lungo
    ! l'albero, ricorsivamente
    if (id == 0) rfalse;
    if (id provides react_before) if (id.react_before(cmd)) rtrue;
    if (child(id)) if (DoReactBeforeFrom(child(id), cmd)) rtrue;
    if (sibling(id)) if (DoReactBeforeFrom(sibling(id), cmd)) rtrue;
    rfalse;
];

[ DoReactAfter cmd;
    ! Azioni da fare una volta eseguito comando
    !print "*** react after ***: ", (name)lastlocation, "^";
    DoReactAfterFrom(printedloc, cmd); !!! ATTENZIONE
    DoReactAfterFrom(player, cmd);
    !lastlocation=location;
];

[ DoReactAfterFrom id cmd;
    ! Eseguo la propriet@`a react_after di id, poi proseguo lungo
    ! l'albero, ricorsivamente
    if (id == 0) rfalse;
    if (id provides react_after) id.react_after(cmd);
    if (child(id)) DoReactAfterFrom(child(id), cmd);
    if (sibling(id)) DoReactAfterFrom(sibling(id), cmd);
];

[ DoEachTurn x;
    ! Azioni di fine turno
    ! Chiamo la proprieta' each_turn di ogni estensione
    !if (location ~= printedloc) rfalse; ! Se @`e cambiata locazione, viene eseguito dopo
    ! print "*** each turn *** ", (name)location, "^";
    objectloop (x in LibraryExtensions) {
      if (x provides each_turn) x.each_turn();
    }  
    DoEachTurnFrom(location);
    DoEachTurnFrom(player);
    TimePasses();
];

[ DoEachTurnFrom id;
    ! Eseguo la propriet@`a each_turn di id, poi proseguo lungo
    ! l'albero, ricorsivamente
    if (id == 0) rfalse;
    if (id provides each_turn) id.each_turn();
    if (child(id)) DoEachTurnFrom(child(id));
    if (sibling(id)) DoEachTurnFrom(sibling(id));
];

[ TestMap id loc i n;
    ! Controllo che la location id sia contenuta nella propriet@`a map
    ! del nodo loc o, se usata con un solo parametro, della location
    if (loc == 0) loc = location;
    if (id ofclass Node && loc provides map) {
        n = loc.#map / WORDSIZE;
        for (i=0: i<n: i++)
            if (id == loc.&map-->i) rtrue;
    }
    rfalse;
];

[ IsNear id loc n i;
    ! Controlla se una locazione @`e adiacente ad un altra o,
    ! se usata con un solo parametro, alla locazione corrente
    ! anche attraverso submap
    if (loc == 0) loc = location;
    if (TestMap(id)) rtrue;
    if (id ofclass Node && loc provides submap) {
        n = loc.#submap /WORDSIZE;
        for (i=0: i<n: i=i+2) {
            if (loc.&submap-->i == id) rtrue;
        }
    }
    rfalse;
];

[ EvalSubMap id loc n i x;
    ! Effettua le sostituzioni della proprieta submap per il nodo
    ! id a partire dal nodo loc (default: location, come sopra)
    if (loc == 0) loc = location;
    if (id ofclass Node && loc provides submap) {
        !if (metaclass(loc.submap) == Routine) return(loc.submap(id));
        n = loc.#submap / WORDSIZE;
        for (i=0: i<(n-1): i=i+2)
            if (id == loc.&submap-->i) {
              x = loc.&submap-->(i+1);
              if (metaclass(x) == Routine) return(x());
               else return x;
            }
    }
    rfalse;    
];

[ GetLink x;
    ! Aspetto che venga cliccato un link nella finestra principale, nella
    ! finestra statusline o in qualche finestra definita in un'estensione
    glk_request_hyperlink_event(gg_mainwin);
    if (gg_statuswin) glk_request_hyperlink_event(gg_statuswin);
    objectloop (x in LibraryExtensions) {
      if (x provides request) x.request();
    }
    if (gg_mainwin) glk_request_char_event(gg_mainwin);
    glk_select(gg_event);
    HandleGlkEventExt(gg_event);
    !print gg_event-->0;
    if (gg_event-->0 == evtype_Hyperlink) {
        glk_cancel_char_event(gg_mainwin);
        if (gg_event-->1 ~= gg_mainwin) glk_cancel_hyperlink_event(gg_mainwin);
        if (gg_statuswin) if (gg_event-->1 ~= gg_statuswin) glk_cancel_hyperlink_event(gg_statuswin);
        x = gg_event-->2;
        if (linktimer >= 0 && x == lastlink && (linktimer-lastlinktimer)<4) return 0;
        lastlinktimer=linktimer;
        lastlink=x;
        return x;
    }
    if (gg_event-->0 == evtype_CharInput) { 
        keypressed = gg_event-->2; 
        !glk_cancel_char_event(gg_mainwin);
        glk_cancel_hyperlink_event(gg_mainwin);
        if (gg_statuswin) glk_cancel_hyperlink_event(gg_statuswin);
        return -1; }
    glk_cancel_char_event(gg_mainwin);
    glk_cancel_hyperlink_event(gg_mainwin);
    if (gg_statuswin) glk_cancel_hyperlink_event(gg_statuswin);
    objectloop (x in LibraryExtensions) {
      if (x provides cancel) x.cancel();
    }    
    return 0;
    ! TODO: Sono praticamente sicuro che dovrei rimuovere le request
    ! che non sono giunte a buon fine. Infatti Quixe s'incazza
    ! Credo di averlo fatto, ma Quixe si incazza ancora
    ! Piu' che altro dovrei verificare i cancel nelle estensioni
];

[ GetLinkKey list id x n i;
    id=GetLink();
    if (id < 0) {
        objectloop(x in list && x provides keys) {
            n = x.#keys / WORDSIZE;
            for (i=0:i<n:i++) {
                if (keypressed == x.&keys-->i) return x;
            }
        }
    };
    return id;
];

#IfDef STATUS_WIN_UFRAME;
[ DrawStatusFrame fg bg;
    bg = 0; fg = $FFFFFF;
    if (gs_graphic) {
    ! Se e' definita la costante STATUS_WIN_UFRAME e l'interprete supporta
    ! la grafica, creo una piccola finestra grafica con una linea per separare 
    ! la finestre principale dalla statusline
        if (glk_style_measure(gg_statuswin, style_Normal, stylehint_TextColor, gg_arguments)) 
            fg = gg_arguments --> 0;
        if (glk_style_measure(gg_statuswin, style_Normal, stylehint_BackColor, gg_arguments)) 
            bg = gg_arguments --> 0;
        if (gg_statuswinuf == 0) {
            gg_statuswinuf = glk_window_open(gg_mainwin, (winmethod_Above+winmethod_Fixed), 4, wintype_Graphics, GG_STATUSWINUF_ROCK);
        }    
        glk_window_set_background_color(gg_statuswinuf, bg); 
        glk_window_clear(gg_statuswinuf);        
        glk_window_fill_rect(gg_statuswinuf,fg,1,1,4096,2);
    }
];
#EndIf;
Stub DrawStatusFrame 0;

[ DrawStatus wx;
    ! Aggiorno la statusline
    if (gg_statuswin == 0) rfalse;
    glk_set_window(gg_statuswin);
    !SetStyle(style_Alert);
    glk_window_clear(gg_statuswin);
    if (location) {
      glk_window_move_cursor(gg_statuswin,0,0);
      print (name)location;
    }
    if (statuscommands) {
      ! Quanto e' larga?
      glk_window_get_size(gg_statuswin, gg_arguments, gg_arguments+WORDSIZE);
      wx = gg_arguments-->0;
      ! Se e' meno di 56 stampo i link compatti
      if (wx < 56) {
          glk_window_move_cursor(gg_statuswin,wx-17,0); print " ";
  #IfDef DEBUG; ! Se esiste la costante DEBUG stampo anche la voce SKIP
          glk_window_move_cursor(gg_statuswin,wx-21,0); print " ";
          link(skiplink); print "[S]"; link(0); print " ";
  #EndIf;        
          link(invlink); print "[I]"; link(0); print " ";
          link(looklink); print "[L]"; link(0); print " ";
          link(waitlink); print "[W]"; link(0); print " ";
          link(menulink); print "[M]"; link(0); print " ";
      } else {  
          glk_window_move_cursor(gg_statuswin,wx-29,0); print "  ";
  #IfDef DEBUG; ! Se esiste la costante DEBUG stampo anche la voce SKIP
          glk_window_move_cursor(gg_statuswin,wx-36,0); print " ";
          link(skiplink); print "[SKIP]"; link(0); print " ";
  #EndIf;         
          link(invlink); print "[INV]"; link(0); print " ";
          link(looklink); print "[LOOK]"; link(0); print " ";
          link(waitlink); print "[WAIT]"; link(0); print " ";
          link(menulink); print "[MENU]"; link(0); print " ";
      }
    }
    !SetStyle(style_Normal);
    glk_set_window(gg_mainwin);
];

[ Inventory x c i;
    ! Inventario: stampo i figli di player
    c = 0; i =0;
    objectloop(x in player) c++;
    if (c == 0) "Al momento non hai niente.^";
    print "Hai con te ";
    objectloop(x in player) {
        link(x);
        PrintArtName(x,1);
        link(0);
        if (i < (c-2)) print ", ";
        if (i == (c-2)) print " e ";
        i++;
    }
    print ".^^";
#Ifndef AUTOTOOL;    
    if (usedtool) print "Stai utilizzando ", (artname)usedtool, ".^^";
#EndIf;
    rtrue;
];

Object systemmenu;
MLink -> restorelink with
    command "Carica",
    keys 'c' 'C' 'l' 'L',
    description [; RestoreGame(); ];
MLink -> savelink with
    command "Salva",
    keys 's' 'S',
    description [; SaveGame(); ];
!MLink -> restartlink with
!    command "Ricomincia",
!    description [; RestartGame(); ];
MLink -> quitlink with
    command "Esci",
    keys 'e' 'E' 'q' 'Q',
    description [; AskQuitGame(); ];
MLink -> restartlink with
    command "Ricomincia",
    keys 'r' 'R',
    description [; AskRestartGame(); ];
MLink -> continuelink with
    command "Continua",
    keys ' ' keycode_Escape,
    description [;];

[ LineMenu pmenu cont; return(_LineMenu(pmenu,cont)); ];

[ _LineMenu pmenu cont id;
    if (~~cont) {
      if (pmenu provides description) print (string)pmenu.description;
      objectloop(id in pmenu)
          if (id ofclass MLink) {
              link(id);
              print "[", (string)id.command, "]";
              link(0);
              print " ";
          }
      print "^^";
    }
    while(true) {
        id = 0;
        while (id == 0) id = GetLinkKey(pmenu);
        if ((id ofclass MLink) && (id in pmenu)) {
            return(id.description());
        }
!        if (id < 0) {
!          objectloop(id in pmenu && id provides keys) {
!            n = id.#keys / WORDSIZE;
!            for (i=0:i<n:i++) {
!              if (keypressed == id.&keys-->i) {
!                res=id.description();
!                return res;
!              }
!            }
!          }
!        }
    }
    id = 0;
];

[ AskQuitGame; return(_AskQuitGame()); ];
[ _AskQuitGame id;
    ! Quit?
    print "Vuoi veramente uscire? (", (rule)ltext(yeslink, "S@`i"), "/", (rule)ltext(nolink, "No"), ")";
    while(true) {
        id = 0;
        while (id == 0) id = GetLinkKey(choicelinks);
        ! Accettavo solo i link si/no e i tasti n, s e y
        ! Con n ridescrivo il nodo corrente
        !if (id < 0) {
        !    if (keypressed == keycode_Escape or 'n' or 'N') { printedloc = 0; print "^^"; rfalse; }
        !    if (keypressed == 's' or 'S' or 'y' or 'Y') { QuitGame(); rtrue; }
        !}
        if (id ofclass MLink) {
          if (id == nolink) { printedloc = 0; print "^^"; rfalse; }
          if (id == yeslink) { QuitGame(); rtrue; }
        }
    }
];

[ AskRestartGame; return(_AskRestartGame()); ];
[ _AskRestartGame id;
    ! Quit?
    print "Vuoi veramente ricominciare? (", (rule)ltext(yeslink, "S@`i"), "/", (rule)ltext(nolink, "No"), ")";
    while(true) {
        id = 0;
        while (id == 0) id = GetLinkKey(choicelinks);
        if (id ofclass MLink) {
          if (id == nolink) { printedloc = 0; print "^^"; rfalse; }
          if (id == yeslink) { RestartGame(); rtrue; }
        }
    }
];

Default WAITSTRING "[. . .]"; ! La posso ridefinire
[ Wait nocr; return(_Wait(nocr)); ];
[ _Wait nocr id;
    ! L'equivalente di "Press any key"
    link(morelink); print (string)WAITSTRING; link(0); 
    while(true) {
        id = 0;
        while (id == 0) id = GetLinkKey(choicelinks);
        ! Accetto solo il link, il comando WAIT o i tasti Esc, Invio, Tab o Spazio
        !if (id < 0) if (keypressed == keycode_Escape or keycode_Return or keycode_Tab or ' ') rtrue;
        if (id ofclass KeyLink or MLink) if (id == morelink or waitlink) 
            if (nocr) rtrue; else "";
    }
];

Array GenString -> 160 + WORDSIZE;

Object linklibdummy
  with article 0;

Include ">linksys.h"; ! Operazioni di sistema 
Include ">linkstuff.h"; ! Classi
